package ru.dbotthepony.mc.otm.data.world

import net.minecraft.util.RandomSource
import net.minecraft.util.valueproviders.IntProvider
import net.minecraft.util.valueproviders.IntProviderType
import ru.dbotthepony.mc.otm.registry.data.MNumberProviders

class OneOfIntProvider(private val provider: OneOfProvider<IntProvider>) : IntProvider() {
	override fun sample(random: RandomSource): Int {
		return provider.select(random).sample(random)
	}

	override fun getMinValue(): Int {
		return provider.children.minOf { it.minValue }
	}

	override fun getMaxValue(): Int {
		return provider.children.minOf { it.maxValue }
	}

	override fun getType(): IntProviderType<*> {
		return MNumberProviders.ONE_OF_INT
	}

	companion object {
		@JvmStatic
		fun of(vararg providers: IntProvider): OneOfIntProvider {
			return OneOfIntProvider(OneOfProvider.of(*providers))
		}

		@JvmStatic
		fun of(providers: Collection<IntProvider>): OneOfIntProvider {
			return OneOfIntProvider(OneOfProvider.of(providers))
		}

		val CODEC = OneOfProvider.createCodec(IntProvider.CODEC, ::OneOfIntProvider, OneOfIntProvider::provider)
	}
}
